#ifndef _CFGFILE_H_
#define _CFGFILE_H_

#include "common.h"

START_EXTERN_C
u8 load_configfile(char *filename, const char *ctemplate, void(*exitfunc)());
extern const char *(*get_config_string)(const char *section, const char *name);
extern u8 (*set_config_string)(const char *section, const char *name, const char *value);
extern s64 (*get_config_int)(s64 defaultreturnvalue, const char *section, const char *name);
extern u8 (*set_config_int)(const char *section, const char *name, s64 value);
extern void (*exit_configfile)();
extern u8 (*flush_configfile)();

extern u8 configfile_cannot_create;
extern u8 configfile_no_section_and_name;
extern u8 configfile_no_value;
END_EXTERN_C

#endif

