#! /bin/sh

if [ ! -x ../MinGW_configure.sh ]; then
	exit 1
fi

if [ -z $1 ]; then
	_sh_arch=i586
else
	_sh_arch=$1
fi

optcl="-pipe -O3 -funroll-loops -fforce-addr -fomit-frame-pointer -march=$_sh_arch"

shift

../configure\
 --host=i686-pc-mingw32\
 --target=i686-pc-mingw32 $@\
 CFLAGS="$optcl"\
 CXXFLAGS="$optcl"\
 CPPFLAGS="-DNDEBUG"

