#! /bin/sh

if [ ! -x ../MinGW_configure.sh ]; then
	exit 1
fi

./configure\
 --enable-cross-compile\
 --cross-prefix=i686-pc-mingw32-\
 --arch=i686\
 --target-os=mingw32\
 --enable-shared\
 --extra-cflags="-mms-bitfields"\
 --extra-ldflags="-mno-cygwin -Wl,--add-stdcall-alias"\
 --enable-small\
 --disable-asm\
 --disable-network\
 --disable-fastdiv\
 --disable-decoders\
 --disable-demuxers\
 --disable-parsers\
 --disable-protocols\
 --disable-devices\
 --enable-memalign-hack

# --disable-aandct\
# --disable-dct\
# --disable-fft\
# --disable-golomb\
# --disable-lpc\
# --disable-mdct\
# --disable-rdft\
# --disable-vaapi\
# --disable-vdpau\
# --disable-dxva2\

