#include "uosnesw.h"
#include "snes9x.h"
#include "memmap.h"
#include "display.h"
#include "cheats.h"
#include <richedit.h>
#include "cheatdlg.h"
#include "memview.h"

static char tmpcharbuf[256];

static LRESULT CALLBACK MemViewSubProc (HWND hWnd, UINT uMsg,
					WPARAM wParam, LPARAM lParam);

static LRESULT CALLBACK MemViewJumpSubProc (HWND hWnd, UINT uMsg,
					    WPARAM wParam, LPARAM lParam);

static void DisplayMemView (int curpage, DWORD curcaretpos);
static uint32 GetMemViewAddress(int curpage, DWORD curcaretpos);

static void NextCaretPos(int &curpage, DWORD &curcaretpos);
static void PreviousCaretPos(int &curpage, DWORD &curcaretpos);

static HWND hMemView;
static HWND hMemViewJump;
static WNDPROC MemViewProc;
static WNDPROC MemViewJumpProc;
static int CurPage = 0;
static DWORD CurCaretPos = 9;
static int CurMode;
static BOOL ModifyPAR;
static uint8 ModifiedValue;
static BOOL Modifying;

LRESULT
MemViewDlgProc (HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam,
		LRESULT ret)
{
  switch (uMsg)
    {

    case WM_INITDIALOG:
      {
	hMemView = GetDlgItem (hWnd, IDC_RICHEDIT_MEMVIEW);

	// Set Window Sub Class
	MemViewProc = (WNDPROC) GetWindowLong (hMemView, GWL_WNDPROC);
	SetWindowLong (hMemView, GWL_WNDPROC, (LONG) MemViewSubProc);

	//set LineSpacing
	PARAFORMAT2 pf;
	ZeroMemory ((void *) &pf, sizeof (pf));
	pf.cbSize = sizeof (pf);
	pf.dwMask = PFM_LINESPACING | PFM_SPACEBEFORE | PFM_SPACEAFTER;
	pf.bLineSpacingRule = 4;
	pf.dyLineSpacing = 210;	//  1 twip == 1/20 point
	pf.dySpaceBefore = 0;
	pf.dySpaceAfter = 0;
	SendMessage (hMemView, EM_SETPARAFORMAT, 0, (LPARAM) & pf);

	//60 byte
	//000000 : 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00  CV
	//
	//"\r\n" == 2 byte
	//
	SendMessage (hMemView, EM_SETLIMITTEXT, (WPARAM) 62 * 16, 0);

	hMemViewJump = GetDlgItem (hWnd, IDC_EDIT_MEMVIEWJUMP);
	MemViewJumpProc = (WNDPROC) GetWindowLong (hMemViewJump, GWL_WNDPROC);
	SetWindowLong (hMemViewJump, GWL_WNDPROC, (LONG) MemViewJumpSubProc);
	SendMessage (hMemViewJump, EM_SETLIMITTEXT, (WPARAM) 6, 0);

	EnableWindow (GetDlgItem (hWnd, IDC_BUTTON_MEMVIEWJUMP), FALSE);

	SendMessage (GetDlgItem (hWnd, IDC_CHECK_MEMMODIFYTOPAR), BM_SETCHECK,
		     (WPARAM) (ModifyPAR ? BST_CHECKED :
			       BST_UNCHECKED), 0);

	DisplayMemView (CurPage, CurCaretPos);
	Modifying = FALSE;
      }
      break;

    case WM_COMMAND:
      switch (LOWORD (wParam))
	{
	case IDC_CHECK_MEMMODIFYTOPAR:
	  if (HIWORD (wParam) == BN_CLICKED)
	    {
	      ModifyPAR =
		(BOOL) (IsDlgButtonChecked (hWnd, (int) LOWORD (wParam)) ==
			BST_CHECKED);
	    }
	  break;

	case IDOK:
	  if (GetFocus () == hMemViewJump)//Get Enter Key down
	    {
	      int len = GetWindowTextLength (hMemViewJump);
	      if (1 <= len  && len <= 6)
		PostMessage (hWnd, WM_COMMAND, IDC_BUTTON_MEMVIEWJUMP, 0);
	    }
	  break;

	case IDC_EDIT_MEMVIEWJUMP:
	  if (HIWORD (wParam) == EN_CHANGE)
	    {
	      int len = GetWindowTextLength ((HWND) lParam);
	      if (1 <= len  && len <= 6)
		EnableWindow (GetDlgItem (hWnd, IDC_BUTTON_MEMVIEWJUMP),
			      TRUE);
	      else
		EnableWindow (GetDlgItem (hWnd, IDC_BUTTON_MEMVIEWJUMP),
			      FALSE);
	    }
	  break;

	case IDC_BUTTON_MEMVIEWJUMP:
	  {
	    int len = GetWindowTextLength (hMemViewJump);
	    if (1 <= len  && len <= 6)
	      {
		uint32 addr = 0;
		unsigned char charbuf[16];
		GetWindowText (hMemViewJump, (LPTSTR) charbuf, 7);

		for (int i = 0; i < len; i++)
		  {
		    if (charbuf[(len - 1) - i] >= 0x30
			&& charbuf[(len - 1) - i] <= 0x39)//0-9
		      addr |= (charbuf[(len - 1) - i] & 0x0f) << (i * 4);
		    else if (charbuf[(len - 1) - i] >= 0x41
			     && charbuf[(len - 1) - i] <= 0x46)//A-F
		      addr |= (charbuf[(len - 1) - i] - 55) << (i * 4);
		    else if (charbuf[(len - 1) - i] >= 0x61
			     && charbuf[(len - 1) - i] <= 0x66)//a-f
		      addr |= (charbuf[(len - 1) - i] - 87) << (i * 4);
		  }
		CurPage = addr >> 8;
		CurCaretPos = 9 + ((addr & 0xF0) >> 4) * (60 + 2) + (addr & 0x0F) * 3;

		SetFocus (hMemView);
		DisplayMemView (CurPage, CurCaretPos);
		Modifying = FALSE;
	      }
	  }
	  break;

	case IDC_BUTTON_MEMSAVE:
	  {
	    if(SNESCheatMessageTimerActive) {
	      KillTimer(hWnd, 110);
	      SNESCheatMessageTimerActive = FALSE;
	    }
	    int savednum;
	    const char *numfilename = S9xGetFilenameInc(".mmb", BINDUMP_DIR);
	    HANDLE hFile = CreateFile((LPCTSTR)numfilename, GENERIC_WRITE, 0, 0, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
	    if (hFile == INVALID_HANDLE_VALUE) {
	      SendMessage(hSNESCheatStatusWnd, SB_SETTEXT, 255 | 0, (WPARAM)(GUI.Language == 1 ? "G[I" : "Error!"));
	      SetTimer(hWnd, 110, 2500, NULL);
	      SNESCheatMessageTimerActive = TRUE;
	      break;
	    }

	    DWORD WriteByte = 0xFFFFFFFF;

	    uint8 zerobuf[MEMMAP_BLOCK_SIZE];
	    ZeroMemory(zerobuf, MEMMAP_BLOCK_SIZE);

	    for(uint32 addr = 0; addr < 0x1000000 ; addr += MEMMAP_BLOCK_SIZE)
	      {
		uint8 *p = S9xGetMemPointer (addr);
		if(p)
		  WriteFile(hFile, (LPCVOID)p, (DWORD)MEMMAP_BLOCK_SIZE, &WriteByte, NULL);
		else
		  WriteFile(hFile, (LPCVOID)zerobuf, (DWORD)MEMMAP_BLOCK_SIZE, &WriteByte, NULL);

		if(WriteByte != MEMMAP_BLOCK_SIZE)
		  {
		    WriteByte = 0xFFFFFFFF;
		    break;
		  }
	      }

	    CloseHandle(hFile);
	    if(WriteByte == 0xFFFFFFFF) {
	      SendMessage(hSNESCheatStatusWnd, SB_SETTEXT, 255 | 0, (WPARAM)(GUI.Language == 1 ? "G[I" : "Error!"));
	      SetTimer(hWnd, 110, 2500, NULL);
	      SNESCheatMessageTimerActive = TRUE;
	      break;
	    }
	    lstrcpy(tmpcharbuf, S9xGetFilenameIncNumExt ());
	    lstrcat(tmpcharbuf, (GUI.Language == 1 ? " Z[u" : " saved"));
	    SendMessage(hSNESCheatStatusWnd, SB_SETTEXT, 255 | 0, (WPARAM)tmpcharbuf);
	    SetTimer(hWnd, 110, 2500, NULL);
	    SNESCheatMessageTimerActive = TRUE;
	  }
	  break;

	default:
	  break;
	}
      break;

    case WM_DESTROY:
      //release sub class
      SetWindowLong (hMemView, GWL_WNDPROC,
		     (LONG) MemViewProc);
      SetWindowLong (hMemViewJump, GWL_WNDPROC,
		     (LONG) MemViewJumpProc);
      break;

    default:
      break;
    }

  return ret;
}


static LRESULT CALLBACK
MemViewSubProc (HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
  switch (uMsg)
    {
    case WM_CHAR:
      if ((LOWORD (wParam) >= '0' && LOWORD (wParam) <= '9') ||
	  (LOWORD (wParam) >= 'a' && LOWORD (wParam) <= 'f') ||
	  (LOWORD (wParam) >= 'A' && LOWORD (wParam) <= 'F'))
	{
	  BYTE c = (BYTE)LOWORD (wParam);

	  if(c >= '0' && c <= '9')
	    c &= 0x0F;
	  else if (c >= 'A' && c <= 'F')
	    c -= 55;
	  else if (c >= 'a' && c <= 'f')
	    c -= 87;

	  if(!Modifying)
	    ModifiedValue = 0;

	  ModifiedValue |= c << (Modifying ? 0 : 4);

	  if(Modifying)
	    {
	      char charbuf[16];
	      uint32 addr = GetMemViewAddress(CurPage, CurCaretPos);

	      if(ModifyPAR)
		{
		  wsprintf(charbuf, "%08X", (addr << 8) | ModifiedValue);
		  SetWindowText (GetDlgItem (GetParent(hWnd), IDC_EDIT_SNESCHEATENTER), (LPCTSTR) charbuf);
		  PostMessage (GetParent(hWnd), WM_COMMAND, IDC_BUTTON_SNESCHEATADD, 0);
		}
	      else
		{
		  uint8 *p = S9xGetMemPointer (addr);
		  if(p)
		    {
		      *p = ModifiedValue;
		      
		      CPU.WaitAddress = 0xffffffff;
		      CPU.WaitCounter = 1;//uosnes
		      SA1.WaitCounter = 0;

		      wsprintf(charbuf, "%02X", ModifiedValue);
		      SendMessage (hMemView, EM_SETSEL, (WPARAM)CurCaretPos, (LPARAM)CurCaretPos + 2);
		      SendMessage (hMemView, EM_REPLACESEL, 0, (LPARAM) ((LPSTR) charbuf));
		      SendMessage (hMemView, EM_SETSEL, (WPARAM)CurCaretPos, (LPARAM)CurCaretPos);
		    }
		}
	      NextCaretPos(CurPage, CurCaretPos);
	      Modifying = FALSE;
	    }
	  else
	    Modifying = TRUE;
	  return 0;
	}
      return 0;

    case WM_KEYDOWN:
      switch (wParam)
	{
	case VK_BACK:
	case VK_DELETE:
	  return 0;

	  // cut & paste
	case 'V':
	case 'X':
	  if ((GetKeyState (VK_CONTROL) & 0x8000) == 0)
	    break;
	  return 0;

	case VK_PRIOR:
	  if (CurPage > 0)
	    {
	      --CurPage;
	      DisplayMemView (CurPage, CurCaretPos);
	      Modifying = FALSE;
	    }
	  return 0;

	case VK_NEXT:
	  if (CurPage < (0x10000 - 1))
	    {
	      ++CurPage;
	      DisplayMemView (CurPage, CurCaretPos);
	      Modifying = FALSE;
	    }
	  return 0;

	case VK_HOME:
	  if (CurPage > 0)
	    {
	      CurPage = 0;
	      DisplayMemView (CurPage, CurCaretPos);
	      Modifying = FALSE;
	    }
	  return 0;

	case VK_END:
	  if (CurPage < (0x10000 - 1))
	    {
	      CurPage = (0x10000 - 1);
	      DisplayMemView (CurPage, CurCaretPos);
	      Modifying = FALSE;
	    }
	  return 0;

	case VK_UP:
	  if (CurCaretPos < (60 + 2) + 9)
	    {
	      if (CurPage > 0)
		{
		  CurCaretPos += (60 + 2) * 15;
		  --CurPage;
		  DisplayMemView (CurPage, CurCaretPos);
		  Modifying = FALSE;
		}
	    }
	  else
	    {
	      CurCaretPos -= (60 + 2);
	      SendMessage (hWnd, EM_SETSEL, (WPARAM) CurCaretPos,
			   (LPARAM) CurCaretPos);
	      Modifying = FALSE;
	    }
	  return 0;

	case VK_DOWN:
	  if (CurCaretPos >= (60 + 2) * 15 + 9)
	    {
	      if (CurPage < (0x10000 - 1))
		{
		  CurCaretPos -= (60 + 2) * 15;
		  ++CurPage;
		  DisplayMemView (CurPage, CurCaretPos);
		  Modifying = FALSE;
		}
	    }
	  else
	    {
	      CurCaretPos += (60 + 2);
	      SendMessage (hWnd, EM_SETSEL, (WPARAM) CurCaretPos,
			   (LPARAM) CurCaretPos);
	      Modifying = FALSE;
	    }
	  return 0;


	case VK_LEFT:
	  PreviousCaretPos(CurPage, CurCaretPos);
	  return 0;

	case VK_RIGHT:
	  NextCaretPos(CurPage, CurCaretPos);
	  return 0;

	case VK_ESCAPE:
	  break;

	default:
	  return 0;
	}
      break;

    case WM_LBUTTONDOWN:
      {
	SetFocus (hWnd);

	DWORD dwRet, caretpos;
	POINT pt;

	GetCursorPos(&pt);
	ScreenToClient(hWnd, &pt);

	POINTL ptl = {pt.x, pt.y};

	// RichEdit needs POINTL structure address
	//dwRet = (DWORD)SendMessage(hWnd, EM_CHARFROMPOS, 0, (LPARAM)MAKELPARAM(pt.x, pt.y));
	dwRet = (DWORD)SendMessage(hWnd, EM_CHARFROMPOS, 0, (LPARAM)&ptl);
	caretpos = LOWORD(dwRet);

#if 0
	char charbuf[256];
	wsprintf(charbuf, "%d", caretpos);
	MessageBox (GUI.hWnd,
		    charbuf,
		    "uosnes", MB_OK | MB_ICONINFORMATION);
#endif

	if(caretpos < 9 + 2)
	  caretpos = 9;
	else if(caretpos > (60 + 2) * 15 + 54 + 2)
	  caretpos = (60 + 2) * 15 + 54;
	else
	  {
	    int index = caretpos % (60 + 2);

	    if(index < 9)
	      index = 9;
	    else if(index > 54)
	      index = 54;

	    if((index - 9) % 3 < 2)
	      index = 9 + ((index - 9) / 3) * 3;
	    else if((index - 9) % 3 >= 2)
	      index = 9 + ((index - 9) / 3 + 1) * 3;

	    caretpos = caretpos - (caretpos % (60 + 2)) + index;
	  }
	CurCaretPos = caretpos;
	SendMessage (hWnd, EM_SETSEL, (WPARAM) CurCaretPos,
		     (LPARAM) CurCaretPos);
	Modifying = FALSE;
      }
      return 0;

    case WM_CUT:
    case WM_COPY:
    case WM_PASTE:
    case WM_UNDO:
      return 0;

    default:
      break;

    }
  return (CallWindowProc (MemViewProc, hWnd, uMsg, wParam, lParam));
}

static LRESULT CALLBACK
MemViewJumpSubProc (HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
  switch (uMsg)
    {
    case WM_CHAR:
      if (LOWORD (wParam) >= '0' && LOWORD (wParam) <= '9')
	break;
      else if (LOWORD (wParam) >= 'a' && LOWORD (wParam) <= 'f')
	{
	  wParam = (wParam & ~0xFFFF) | LOWORD (wParam) - 0x20;
	  break;
	}
      else if (LOWORD (wParam) >= 'A' && LOWORD (wParam) <= 'F')
	break;
      else if (LOWORD (wParam) == VK_BACK || LOWORD (wParam) == VK_DELETE)
	break;
      return 0;

      //case WM_PASTE:
      //return 0;

    default:
      break;

    }
  return (CallWindowProc (MemViewJumpProc, hWnd, uMsg, wParam, lParam));
}

static void
DisplayMemView (int curpage, DWORD curcaretpos)
{
  if (curpage >= 0x10000)
    return;

  uint8 *p = S9xGetMemPointer ((uint32) (curpage * 256));

  char charbuf[(60 + 2) * 16 + 16];

  if (p)
    {
      for (int addr = 0; addr < 256; addr += 16)
	wsprintf (&charbuf[(60 + 2) * (addr / 16)],
		  "%06X : %02X %02X %02X %02X %02X %02X %02X %02X %02X %02X %02X %02X %02X %02X %02X %02X  CV\r\n",
		  curpage * 256 + addr, p[addr + 0], p[addr + 1], p[addr + 2],
		  p[addr + 3], p[addr + 4], p[addr + 5], p[addr + 6],
		  p[addr + 7], p[addr + 8], p[addr + 9], p[addr + 10],
		  p[addr + 11], p[addr + 12], p[addr + 13], p[addr + 14],
		  p[addr + 15]);
    }
  else
    {
      for (int addr = 0; addr < 256; addr += 16)
	wsprintf (&charbuf[(60 + 2) * (addr / 16)],
		  "%06X : %02X %02X %02X %02X %02X %02X %02X %02X %02X %02X %02X %02X %02X %02X %02X %02X  CV\r\n",
		  curpage * 256 + addr, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
		  0, 0, 0);
    }

  //DWORD dwStart, dwEnd;
  //SendMessage(hMemView, EM_GETSEL, (WPARAM)&dwStart, (LPARAM)&dwEnd); 

  SetWindowText (hMemView, (LPCTSTR) charbuf);
  SendMessage (hMemView, EM_SETSEL, (WPARAM) curcaretpos,
	       (LPARAM) curcaretpos);

  //add text
  //
  //SetFocus (hMemView);
  //int ndx = GetWindowTextLength (hMemView);
  //SendMessage (hMemView, EM_SETSEL, (WPARAM)ndx, (LPARAM)ndx);
  //SendMessage (hMemView, EM_REPLACESEL, 0, (LPARAM) ((LPSTR) charbuf));
}


static uint32 GetMemViewAddress(int curpage, DWORD curcaretpos)
{
  return (uint32)(curpage * 256 + curcaretpos / (60 + 2) * 16 + ((curcaretpos % (60 + 2) - 9) / 3));
}

static void NextCaretPos(int &curpage, DWORD &curcaretpos)
{
  if (curcaretpos == (60 + 2) * 15 + 54)
    {
      if (curpage < (0x10000 - 1))
	{
	  curcaretpos = 9;
	  ++curpage;
	  DisplayMemView (curpage, curcaretpos);
	  Modifying = FALSE;
	}
    }
  else if (curcaretpos % (60 + 2) == 54)
    {
      curcaretpos += 17;
      SendMessage (hMemView, EM_SETSEL, (WPARAM) curcaretpos,
		   (LPARAM) curcaretpos);
      Modifying = FALSE;
    }
  else
    {
      curcaretpos += 3;
      SendMessage (hMemView, EM_SETSEL, (WPARAM) curcaretpos,
		   (LPARAM) curcaretpos);
      Modifying = FALSE;
    }
}


static void PreviousCaretPos(int &curpage, DWORD &curcaretpos)
{
  if (curcaretpos == 9)
    {
      if (curpage > 0)
	{
	  curcaretpos = (60 + 2) * 15 + 54;
	  --curpage;
	  DisplayMemView (curpage, curcaretpos);
	  Modifying = FALSE;
	}
    }
  else if (curcaretpos % (60 + 2) == 9)
    {
      curcaretpos -= 17;
      SendMessage (hMemView, EM_SETSEL, (WPARAM) curcaretpos,
		   (LPARAM) curcaretpos);
      Modifying = FALSE;
    }
  else
    {
      curcaretpos -= 3;
      SendMessage (hMemView, EM_SETSEL, (WPARAM) curcaretpos,
		   (LPARAM) curcaretpos);
      Modifying = FALSE;
    }
}

void ResetMemview ()
{
  Modifying = FALSE;
  return;
}

