#! /bin/sh

if [ ! -x ../MinGW_configure.sh ]; then
	exit 1
fi

if [ -z $1 ]; then
	_sh_arch=i686
else
	_sh_arch=$1
fi

optcl="-pipe -O3 -funroll-loops -fforce-addr -fno-optimize-sibling-calls -fomit-frame-pointer -ffast-math -march=$_sh_arch -mtune=pentium4"

shift

../configure\
 --host=i686-pc-mingw32\
 --target=i686-pc-mingw32 $@\
 CFLAGS="$optcl"\
 CXXFLAGS="$optcl"\
 CPPFLAGS="-DNDEBUG"

# --enable-zsnes_fx
# --enable-zsnes_c4
# --enable-dma_execute_per_event\
