#ifndef _UOW_INPUT_H_
#define _UOW_INPUT_H_

typedef struct
{
  WORD Left;
  WORD Left_Up;
  WORD Left_Down;
  WORD Right;
  WORD Right_Up;
  WORD Right_Down;
  WORD Up;
  WORD Down;
  WORD Start;
  WORD Select;
  WORD A;
  WORD B;
  WORD X;
  WORD Y;
  WORD L;
  WORD R;
  BOOL Turbo_Left;
  BOOL Turbo_Right;
  BOOL Turbo_Up;
  BOOL Turbo_Down;
  BOOL Turbo_Start;
  BOOL Turbo_Select;
  BOOL Turbo_A;
  BOOL Turbo_B;
  BOOL Turbo_X;
  BOOL Turbo_Y;
  BOOL Turbo_L;
  BOOL Turbo_R;
} SJoypad;

BOOL S9xWinScanJoypads ();
void MakeTurboStatus ();
void uowJoystickInit (HWND hWnd);
void uowReleaseInput ();

extern uint32 joypads[8];
extern SJoypad JoypadA[8];
extern SJoypad JoypadB[8];
extern uint32 TurboStatus[8];
extern DWORD FunctionCodeA[];
extern DWORD FunctionCodeB[];
extern BYTE FunctionCodeStates[];

#define MF_SAVE1 0
#define MF_SAVE2 1
#define MF_LOAD1 2
#define MF_LOAD2 3
#define MF_TURBO 4
#define MF_TURBOPAUSEFWD 5
#define MF_RESET 6
#define MF_SOFTRESET 7
#define MF_SPCDUMP 8
#define MF_SCREENSHOT 9
#define MF_XXX01 10
#define MF_XXX02 11
#define MF_XXX03 12
#define MF_XXX04 13
#define MF_XXX05 14
#define MF_XXX06 15
#define MF_XXX07 16
#define MF_XXX08 17
#define MF_XXX09 18
#define MF_XXX10 19
#define MF_SSTURBO 20
#define MF_SSPAUSE 21
#define MF_LG2_UP 22
#define MF_LG2_DOWN 23
#define MF_LG2_LEFT 24
#define MF_LG2_RIGHT 25
#define MF_LG2_SHOT 26
#define MF_LG2_PAUSE 27
#define MF_LG2_OFFSCREEN 28
#define MF_TURBOSHOT_TOGGLE 29
#define MF_TURBOSHOT_PRESS 30
#define MF_MAX 32

#endif /* _UOW_INPUT_H_ */
